/* GCC */

#include <fstream>
#include <string>
#include <vector>
#include <algorithm>
#include <climits>
using namespace std;

int dejkstra(vector < vector <bool> >& g)
{
    int n = g.size();
    const int start = 0;
    vector<bool> visited(n);
    vector<int> dist(n);
    for (int i=0; i<n; ++i)
    {
        visited[i] = false;
        dist[i] =INT_MAX-1;
    }
    dist[start] = 0;
    int cur_ver = start;
    while (cur_ver != -1)
    {
        visited[cur_ver] = true;
        for (int i =0; i<n; ++i)
            if (dist[i] > dist[cur_ver] + 1 && !visited[i] && g[cur_ver][i])
                dist[i] = dist[cur_ver] + 1;
        int imin = -1, mmin = INT_MAX;
        for (int i =1; i<n; ++i)
            if (dist[i] < mmin && !visited[i])
            {
                mmin = dist[i];
                imin = i;
            }
        cur_ver = imin;
    }
    /*for (int i=0;i<n;++i)
        cerr << dist[i] << ' ';
    cerr << endl;*/
    return dist[n-1];
}

int main()
{
    ifstream fin("journey.in");
    ofstream fout("journey.out");
    int n, m;


    fin >> n >> m;
    fin.get();
    vector < vector<int> > r(m);
    vector < vector <bool> > g;
    for (int i=0; i<n; ++i)
        g.push_back(vector<bool>(n));

    for (int i=0; i < n; ++i)
    {
        string s;
        getline(fin, s);
        //fout << s << endl;
        for (int j=0; j<s.size(); ++j)
        {
            if (s[j] == '1')
                r[j].push_back(i);
        }
    }
    for (int i=0; i<r.size(); ++i)
    {
        for (int j=0; j<r[i].size(); ++j)
        {
            for (int k = j+1; k < r[i].size(); ++k)
            {
                g[r[i][j]][r[i][k]] = g[r[i][k]][r[i][j]] = true;
            }
        }

    }
/*
    for (int j=0; j<g.size(); ++j)
    {
        for (int k = 0; k < g[j].size(); ++k)
        {
            fout << g[j][k] << ' ';

        }
        fout << endl;
    }*/
    fout << dejkstra(g) << endl;;

    fin.close();
    fout.close();
    return 0;
}
