/* GCC */
#include <cstdio>
#include <vector>
#include <set>
#include <utility>
#include <climits>

using namespace std;

vector<int> bfs(vector<vector<int> > edges, int v)
{
    int n = (int)edges.size();
    vector<int> dist(n, INT_MAX);
    dist[v] = 0;
    set<pair<int, int> > q;
    for (int i = 0; i < n; ++i) {
        q.insert(make_pair(i, dist[i]));
    }
    while (!q.empty()) {
        pair<int, int> current = *q.begin();
        q.erase(q.begin());
        for (int i = 0; i < edges[current.first].size(); ++i) {
            if (dist[edges[current.first][i]] > current.second + 1) {
                q.erase(make_pair(edges[current.first][i], dist[edges[current.first][i]]));
                dist[edges[current.first][i]] = current.second + 1;
                q.insert(make_pair(edges[current.first][i], dist[edges[current.first][i]]));
            }
        }
    }
    return dist;
}

int main()
{
    freopen("journey.in", "r", stdin);
    freopen("journey.out", "w", stdout);
    int n, m;
    scanf("%d %d", &n, &m);
    vector<vector<int> > planets(n);
    vector<vector<int> > p(n, vector<int>(m));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            scanf("%1d", &p[i][j]);
        }
    }

    for (int i = 0; i < n; ++i) {
        vector<int> p1 = p[i];
        for (int j = i+1; j < n; ++j) {
            vector<int> p2 = p[j];
            for (int k = 0; k < m; ++k) {
                if (p1[k] == p2[k]) {
                    planets[i].push_back(j);
                    planets[j].push_back(i);
                    break;
                }
            }
        }
    }

    printf("%d\n", bfs(planets, 0).back());

}
